--==========================================================================================================================	
-- CIVILIZATIONS
--==========================================================================================================================	

--lua hook activation
UPDATE CustomModOptions	SET Value = 1 WHERE Name = 'EVENTS_CITY';
	
--More Unique Components for Vox Populi
--------------------------------	
-- Civilization_UnitClassOverrides 
--------------------------------
UPDATE Units SET MinorCivGift = 0, Class = 'UNITCLASS_WARRIOR' WHERE Type = 'UNIT_AKKADIAN_MOD_VULTURE';
UPDATE Units SET MinorCivGift = 0, Class = 'UNITCLASS_CHARIOT_ARCHER' WHERE Type = 'UNIT_LITE_AKKAD_ONAGER_WAGON' AND EXISTS (SELECT * FROM Buildings WHERE Type ='BUILDING_GERMANY_TEUTONIC_ORDER');

--INSERT INTO	Civilization_UnitClassOverrides
--			(CivilizationType,		UnitClassType,				UnitType)
--VALUES		('CIVILIZATION_AKKADIAN_MOD', 'UNITCLASS_CHARIOT_ARCHER',	'UNIT_LITE_AKKAD_ONAGER_WAGON');

INSERT INTO Civilization_UnitClassOverrides
		(CivilizationType, UnitClassType, UnitType)
SELECT	'CIVILIZATION_AKKADIAN_MOD', 'UNITCLASS_CHARIOT_ARCHER', 'UNIT_LITE_AKKAD_ONAGER_WAGON'
WHERE EXISTS (SELECT * FROM Buildings WHERE Type = 'BUILDING_GERMANY_TEUTONIC_ORDER');
--------------------------------	
-- Civilization_BuildingClassOverrides
--------------------------------	
--INSERT INTO	Civilization_BuildingClassOverrides
--			(CivilizationType,		BuildingClassType,			BuildingType)
--VALUES		('CIVILIZATION_AKKADIAN_MOD', 'BUILDINGCLASS_GROVE', 'BUILDING_SUMER_EDUBA');

INSERT INTO Civilization_BuildingClassOverrides
		(CivilizationType, BuildingClassType, BuildingType)
SELECT	'CIVILIZATION_AKKADIAN_MOD', 'BUILDINGCLASS_GROVE', 'BUILDING_SUMER_EDUBA'
WHERE EXISTS (SELECT * FROM Buildings WHERE Type = 'BUILDING_GERMANY_TEUTONIC_ORDER');
--------------------------------	
-- Trigger for the 4UC
--------------------------------	
CREATE TRIGGER SumerForVP_4UC
AFTER INSERT ON Buildings 
WHEN NEW.Type = 'BUILDING_GERMANY_TEUTONIC_ORDER'
BEGIN
	UPDATE Units SET MinorCivGift = 0, Class = 'UNITCLASS_CHARIOT_ARCHER' WHERE Type = 'UNIT_LITE_AKKAD_ONAGER_WAGON';
	
	INSERT INTO Civilization_UnitClassOverrides
			(CivilizationType, UnitClassType, UnitType)
	VALUES	('CIVILIZATION_AKKADIAN_MOD', 'UNITCLASS_CHARIOT_ARCHER', 'UNIT_LITE_AKKAD_ONAGER_WAGON');
	
	INSERT INTO Civilization_BuildingClassOverrides
			(CivilizationType, BuildingClassType, BuildingType)
	VALUES	('CIVILIZATION_AKKADIAN_MOD', 'BUILDINGCLASS_GROVE', 'BUILDING_SUMER_EDUBA');
END;
------------------------------
-- IconTextureAtlases
------------------------------
INSERT INTO IconTextureAtlases 
			(Atlas, 							IconSize, 	Filename, 				IconsPerRow, 	IconsPerColumn)
VALUES		('BUILDING_EDUBA_ATLAS', 			256, 		'SUMER_EDUBA_256.dds',			1, 		1),
			('BUILDING_EDUBA_ATLAS', 			128, 		'SUMER_EDUBA_128.dds',			1, 		1),
			('BUILDING_EDUBA_ATLAS', 			64, 		'SUMER_EDUBA_64.dds',			1, 		1),
			('BUILDING_EDUBA_ATLAS', 			45, 		'SUMER_EDUBA_45.dds',			1, 		1),
			('LITE_AKKAD_ONAGER_WAGON_ATLAS', 	32, 		'AkkadOnagerAlphaAtlas.dds',	1, 		1),
			('LITE_AKKAD_ATLAS', 				256, 		'LITE_Akkad_256.dds',			1, 		1),
			('LITE_AKKAD_ATLAS', 				128, 		'LITE_Akkad_128.dds',			1, 		1),
			('LITE_AKKAD_ATLAS', 				80, 		'LITE_Akkad_80.dds',			1, 		1),
			('LITE_AKKAD_ATLAS', 				64, 		'LITE_Akkad_64.dds',			1, 		1),
			('LITE_AKKAD_ATLAS', 				45, 		'LITE_Akkad_45.dds',			1, 		1),
			('LITE_AKKAD_ATLAS', 				32, 		'LITE_Akkad_32.dds',			1, 		1);
--==========================================================================================================================	

--==========================================================================================================================	
-- BUILDINGS
--==========================================================================================================================	
------------------------------
-- Buildings
------------------------------	
INSERT INTO Buildings 	
			(Type,					BuildingClass,	GoldMaintenance, Cost, FaithCost,	EnhancedYieldTech, TechEnhancedTourism, AllowsRangeStrike, Defense,	ExtraCityHitPoints, TrainedFreePromotion,	CitySupplyFlat,	DefenseHappinessChange, GreatPeopleRateModifier,	GreatWorkSlotType, GreatWorkCount, FreshWater, FreeStartEra, Happiness, NeverCapture, PrereqTech, ArtDefineTag, SpecialistType,	SpecialistCount,	MinAreaSize, ConquestProb, HurryCostModifier,	TradeRouteRecipientBonus,	TradeRouteTargetBonus,	Help,									Description,					Civilopedia,							Strategy,									IconAtlas,				PortraitIndex)
SELECT		'BUILDING_SUMER_EDUBA',	BuildingClass,	GoldMaintenance, Cost, FaithCost,	EnhancedYieldTech, TechEnhancedTourism, AllowsRangeStrike, Defense,	ExtraCityHitPoints, TrainedFreePromotion,	CitySupplyFlat,	DefenseHappinessChange,	GreatPeopleRateModifier,	GreatWorkSlotType, GreatWorkCount, FreshWater, FreeStartEra, Happiness, NeverCapture, PrereqTech, ArtDefineTag, SpecialistType,	SpecialistCount,	MinAreaSize, ConquestProb, HurryCostModifier,	TradeRouteRecipientBonus,	TradeRouteTargetBonus,	'TXT_KEY_BUILDING_SUMER_EDUBA_HELP',	'TXT_KEY_BUILDING_SUMER_EDUBA', 'TXT_KEY_CIVLOPEDIA_BUILDING_SUMER_EDUBA_TEXT',	'TXT_KEY_BUILDING_SUMER_EDUBA_STRATEGY',	'BUILDING_EDUBA_ATLAS',	0
FROM Buildings WHERE Type = 'BUILDING_GROVE';	
------------------------------	
-- Building_Flavors
------------------------------		
INSERT INTO Building_Flavors 	
			(BuildingType, 				FlavorType,			Flavor)
VALUES		('BUILDING_SUMER_EDUBA',	'FLAVOR_SCIENCE',	35),
			('BUILDING_SUMER_EDUBA',	'FLAVOR_GROWTH',	35);

------------------------------	
-- Building_YieldChanges
------------------------------		
INSERT INTO Building_YieldChanges 	
			(BuildingType, 				YieldType,			Yield)
VALUES		('BUILDING_SUMER_EDUBA',	'YIELD_FOOD',		2),
			('BUILDING_SUMER_EDUBA',	'YIELD_SCIENCE',	1);
------------------------------	
-- Building_YieldFromBirth
------------------------------		
INSERT INTO Building_YieldFromBirth	
			(BuildingType, 				YieldType,			Yield)
VALUES		('BUILDING_SUMER_EDUBA',	'YIELD_SCIENCE',	7);

--------------------------------	
-- Building_YieldChangesPerPop
--------------------------------	
INSERT INTO Building_YieldChangesPerPop
			(BuildingType,				YieldType,		Yield)
VALUES		('BUILDING_SUMER_EDUBA',	'YIELD_FOOD',	20);
--==========================================================================================================================
-- ARTDEFINES
--==========================================================================================================================
INSERT INTO ArtDefine_UnitInfos(Type, DamageStates, Formation)
  VALUES ('ART_DEF_UNIT_ONAGER_WAGON_MOD', 1, 'TwoBigGuns');

INSERT INTO ArtDefine_UnitInfoMemberInfos(UnitInfoType, UnitMemberInfoType, NumMembers)
  VALUES ('ART_DEF_UNIT_ONAGER_WAGON_MOD', 'ART_DEF_UNIT_MEMBER_AKKAD_ONAGER_WAGON_MOD', 2);

INSERT INTO ArtDefine_UnitMemberInfos(Type, Scale, Model, MaterialTypeTag, MaterialTypeSoundOverrideTag)
  VALUES ('ART_DEF_UNIT_MEMBER_AKKAD_ONAGER_WAGON_MOD', 0.144999995827675, 'Chariot_Babylon.fxsxml', 'CLOTH', 'WOODSM');

INSERT INTO ArtDefine_UnitMemberCombats(UnitMemberType, EnableActions, ShortMoveRadius, ShortMoveRate, TargetHeight, HasRefaceAfterCombat)
  VALUES ('ART_DEF_UNIT_MEMBER_AKKAD_ONAGER_WAGON_MOD', 'Idle Attack RunCharge AttackCity Bombard Death BombardDefend Run Fortify CombatReady Walk AttackCharge', 12.0, 0.349999994039536, 8.0, 1);

INSERT INTO ArtDefine_UnitMemberCombatWeapons(UnitMemberType, "Index", SubIndex, WeaponTypeTag, WeaponTypeSoundOverrideTag)
  VALUES ('ART_DEF_UNIT_MEMBER_AKKAD_ONAGER_WAGON_MOD', 0, 0, 'METAL', 'SWORD');

INSERT INTO ArtDefine_UnitMemberCombatWeapons(UnitMemberType, "Index", SubIndex, VisKillStrengthMin, VisKillStrengthMax, WeaponTypeTag, MissTargetSlopRadius)
  VALUES ('ART_DEF_UNIT_MEMBER_AKKAD_ONAGER_WAGON_MOD', 1, 0, 10.0, 20.0, 'FLAMING_ARROW', 10.0);